package com.data.datarepo.controller;

import com.data.datarepo.domain.DataRepoTable;
import com.data.datarepo.services.*;
import com.data.datarepo.utils.EquipmentNo;
import com.mysql.cj.util.StringUtils;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Controller
@RequestMapping("/data")
public class DataController {

    DataService dataService = new DataService();
    DataAllService dataAllService = new DataAllService();

    DataListService dataListService = new DataListService();
    DataMySQL2OracleService dataMySQL2OracleService = new DataMySQL2OracleService();
    DataRollBackService dataRollBackService=new DataRollBackService();
    EquipmentNo equipmentNo = new EquipmentNo();

    @RequestMapping("/list")
    public String dataList(HttpServletRequest request, HttpServletResponse response) throws SQLException {
        List<DataRepoTable> DataRepoTableList = new ArrayList<DataRepoTable>();
        String num = request.getParameter("num");
        if (StringUtils.isNullOrEmpty(num)) {
            DataRepoTableList = dataListService.getDataList();
            request.setAttribute("DataRepoTableList", DataRepoTableList);
            return "dataList";
        } else {
            DataRepoTableList = dataListService.getDataNumList(num);
            request.setAttribute("DataRepoTableList", DataRepoTableList);
            return "dataResult";
        }
    }

    @RequestMapping("/repoResult")
    public String datarepoResult(String[] repo_name, HttpServletRequest request, HttpServletResponse response) throws SQLException {
        DataRepoTable dataRepoTable = new DataRepoTable();
        List<DataRepoTable> tableList = new ArrayList<DataRepoTable>();
        String[] value1 = new String[repo_name.length];
        String[] value2 = new String[repo_name.length];
        String[] value3 = new String[repo_name.length];
        String[] value4 = new String[repo_name.length];
        if (repo_name != null) {
            for (int i = 0; i < repo_name.length; i++) {
                String temp = repo_name[i];
                String[] itempsplit = temp.split("-");
                value1[i] = itempsplit[0];
                value2[i] = itempsplit[1];
                value3[i] = itempsplit[2];
                value4[i] = itempsplit[3];
                dataRepoTable = dataService.testSelectResult(value1[i], value2[i], value3[i], value4[i]);
                tableList.add(dataRepoTable);
                System.out.println("表：" + repo_name[i] + "加载完成:100%");
            }
        }
        request.setAttribute("DataRepoTableList", tableList);
        return "dataRepo";
    }

    @RequestMapping("/repo")
    public String datarepo(String[] repo_name, HttpServletRequest request, HttpServletResponse response) {

        DataRepoTable dataRepoTable = new DataRepoTable();
        List<DataRepoTable> tableList = new ArrayList<DataRepoTable>();
        String[] repo_names = new String[repo_name.length];
        String[] table_names = new String[repo_name.length];
        String[] up_nums = new String[repo_name.length];
        String[] table_comments = new String[repo_name.length];
        String[] table_id = new String[repo_name.length];
        SimpleDateFormat f = new SimpleDateFormat("yyyyMMdd");//设置日期格式
        String date = f.format(new Date(System.currentTimeMillis()));
        try{
            String num = equipmentNo.getNewEquipmentNo();
            if (repo_name != null) {
                for (int i = 0; i < repo_name.length; i++) {
                    String temp = repo_name[i];
                    String[] itempsplit = temp.split("-");
                    repo_names[i] = itempsplit[0];
                    table_names[i] = itempsplit[1];
                    up_nums[i] = itempsplit[2];
                    table_comments[i] = itempsplit[3];
                    table_id[i] = itempsplit[4];
                    String up_num="220000000000_"+repo_names[i]+"_"+date+"_"+num;
                    dataRepoTable = dataMySQL2OracleService.startProcess(repo_names[i], table_names[i], up_num, table_comments[i],table_id[i]);
//                dataRepoTable=dataService.testSelect(value1[i],value2[i],value3[i],value4[i]);
                    tableList.add(dataRepoTable);
                    System.out.println("表：" + repo_name[i] + "加载完成:100%");
                }
            }
            request.setAttribute("DataRepoTableList", tableList);
        }catch (Exception e){
            if(tableList != null && !tableList.isEmpty()){
                for(int i=0;i<tableList.size();i++){
                    dataRepoTable=tableList.get(i);
                    dataRollBackService.DataDelete(dataRepoTable.getRepo_name(),dataRepoTable.getUp_num());
                }
            }
            e.printStackTrace();
        }
        return "dataRepo";
    }

    @RequestMapping("/repoBJ")
    public String datarepoBJ(String[] repo_name) throws SQLException {
        String[] value2 = new String[repo_name.length];
        String[] repo_names = new String[repo_name.length];
        String[] up_nums = new String[repo_name.length];
        for (int i = 0; i < repo_name.length; i++) {
            String temp = repo_name[i];
            String[] itempsplit = temp.split("-");
            repo_names[i] = itempsplit[0];
            up_nums[i] = itempsplit[1];
            dataService.testSelectBJ(repo_names[i],up_nums[i]);
        }

        return "redirect:/data/list";
    }

}
