package com.data.datarepo.services;

import com.data.datarepo.domain.DataRepoTable;
import com.data.datarepo.utils.DataSource;
import com.mysql.cj.jdbc.MysqlDataSource;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

public class DataListService {

    public List<DataRepoTable> getDataList() throws SQLException {
        Connection connection = null;
        String selectSQL = "Select * from data_sync_table";
        PreparedStatement prepStmt = null;
        List<DataRepoTable> dataRepoTableList = new ArrayList<DataRepoTable>();
        try {
            MysqlDataSource basicDS = DataSource.getInstance().getMySqlDS();
            connection = basicDS.getConnection();
            prepStmt = connection.prepareStatement(selectSQL);
            ResultSet rs = prepStmt.executeQuery();
            while(rs.next()){
                DataRepoTable dataRepoTable=new DataRepoTable();
                dataRepoTable.setTable_id(rs.getString("table_id"));
                dataRepoTable.setRepo_name(rs.getString("repo_name"));
                dataRepoTable.setTable_comment(rs.getString("table_comment"));
                dataRepoTable.setTable_name(rs.getString("table_name"));
                dataRepoTable.setUp_num(rs.getString("equipmentNo"));
                dataRepoTableList.add(dataRepoTable);
            }
        }catch (Exception e){
            e.printStackTrace();
        }finally {
            if (prepStmt != null) {
                prepStmt.close();
            }
            if (connection != null) {
                connection.close();
            }

        }
        return dataRepoTableList;
    }

    public List<DataRepoTable> getDataNumList(String num) throws SQLException {
        Connection connection = null;
        String selectSQL = "Select * from data_sync_upnum where equipmentNo like'%"+num+"%'";
        PreparedStatement prepStmt = null;
        List<DataRepoTable> dataRepoTableList = new ArrayList<DataRepoTable>();
        try {
            MysqlDataSource basicDS = DataSource.getInstance().getMySqlDS();
            connection = basicDS.getConnection();
            prepStmt = connection.prepareStatement(selectSQL);
            ResultSet rs = prepStmt.executeQuery();
            while(rs.next()){
                DataRepoTable dataRepoTable=new DataRepoTable();
                dataRepoTable.setRepo_name(rs.getString("repo_name"));
                dataRepoTable.setTable_comment(rs.getString("table_comment"));
                dataRepoTable.setTable_name(rs.getString("table_name"));
                dataRepoTable.setUp_num(rs.getString("equipmentNo"));
                dataRepoTableList.add(dataRepoTable);
            }
        }catch (Exception e){
            e.printStackTrace();
        }finally {
            if (prepStmt != null) {
                prepStmt.close();
            }
            if (connection != null) {
                connection.close();
            }

        }
        return dataRepoTableList;
    }
}
