package com.data.datarepo.services;

import com.data.datarepo.domain.DataRepoTable;
import com.data.datarepo.utils.DataSource;
import com.data.datarepo.utils.DataSourceOra;
import com.data.datarepo.utils.EquipmentNo;
import com.data.datarepo.utils.SM4Utils;
import com.mysql.cj.jdbc.MysqlDataSource;
import com.mysql.cj.util.StringUtils;

import javax.sql.rowset.JdbcRowSet;
import java.sql.*;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.Date;

public class DataMySQL2OracleService extends DataSourceOra {
    DataCenterService dataCenterService = new DataCenterService();
    DataDeleteService dataDeleteService = new DataDeleteService();

    public DataRepoTable startProcess(String repo_name, String table_name, String up_num, String table_comment, String table_id) throws Exception {
        dataDeleteService.DataDeleteOld(repo_name, up_num);//清除oracle中数据
        // 创建到两个数据库的连接
//        Class.forName("com.mysql.cj.jdbc.Driver");
        DataRepoTable dataRepoTable = new DataRepoTable();
        MysqlDataSource basicDS = DataSource.getInstance().getMySqlDS();
        Connection connSource = basicDS.getConnection();
        Connection connDest = this.getConn();


        Statement stmt = connSource.createStatement();
        Statement stmtC = connSource.createStatement();
        Statement stmtS = connSource.createStatement();
        Statement stmtT = connSource.createStatement();
        ResultSet rs = null;
        ResultSet rsC = null;
        ResultSet rsS = null;
        ResultSet rsT = null;
        PreparedStatement pstmt = null;
        String timeL = "";
        String sqlC = "select insertSql from data_sync_table where repo_name='" + repo_name + "'";
        rsC = stmtC.executeQuery(sqlC);
        String sqlS = "select table_column,column_issm from data_sync_repo_column where table_id='" + table_id + "' and state='0'";
        rsS = stmtS.executeQuery(sqlS);
        String sqlT = "select count(*) as columnCount from data_sync_repo_column where table_id='" + table_id + "' and state='0'";
        rsT = stmtT.executeQuery(sqlT);

        String inSql = "";
        if (rsC.next()) {
            inSql = rsC.getString("insertSql");
//            System.out.println(inSql);
        }
        try {
            rs = stmt.executeQuery("select * from " + table_name);
            DateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            Date beginTime = new Date();
            String start = df.format(beginTime);
            Long begin = beginTime.getTime();
            System.out.println("任务开始，开始时间为：" + start);

//            ResultSetMetaData rsmd = rs.getMetaData();
//            rsS.last();
//            int numberOfColumns = rsmd.getColumnCount();
            int numberOfColumns = 0;
            if (rsT.next()) {
                numberOfColumns = Integer.parseInt(rsT.getString("columnCount"));
            }
            Map smMap = new HashMap();
            while (rsS.next()) {
                String table_column = rsS.getString("table_column");
                String issm = rsS.getString("column_issm");
                smMap.put(table_column,issm);
            }
            pstmt = connDest.prepareStatement(inSql);

                int j = 0;
                while (rs.next()) {
                    j++;
                    rsS.beforeFirst();
                    for (int i = 1; i <= numberOfColumns - 2; i++) {
                        String value = rs.getString(i);
                        String column_name=rs.getMetaData().getColumnName(i);
                        String issm=(String)smMap.get(column_name);
                        if("0".equals(issm)){
                            SM4Utils sm4 = new SM4Utils();
                            sm4.secretKey = "1234567887654321";
                            value = sm4.decryptData_ECB(value);
                        }
                        if(value != null){
                            value = value.trim();
                            if(value.length() > 18){
                                value.replace(" ","");
                            }
                        }
                        pstmt.setString(i, value);
                    }
                    pstmt.setObject(numberOfColumns - 1, "I");
                    pstmt.setObject(numberOfColumns, up_num);
//                    pstmt.executeUpdate();
                    pstmt.addBatch();
                    if (j % 500 == 0) {
                        pstmt.executeBatch();
                    }
                }
                pstmt.executeBatch();
            Date finishTime = new Date();
            Long end = finishTime.getTime();
            long timeLag = end - begin;
            long day = timeLag / (24 * 60 * 60 * 1000);
            long hour = (timeLag / (60 * 60 * 1000) - day * 24);
            long minute = ((timeLag / (60 * 1000)) - day * 24 * 60 - hour * 60);
            long s = (timeLag / 1000 - day * 24 * 60 * 60 - hour * 60 * 60 - minute * 60);
            System.out.println("用了 " + day + "天 " + hour + "时 " + minute + "分 " + s + "秒");
            System.out.println("任务结束，结束时间为：" + df.format(finishTime));
            dataCenterService.updateData(up_num, repo_name);
            dataDeleteService.DataDelete(repo_name);//清除oracle中数据
            dataRepoTable.setTable_comment(table_comment);
            dataRepoTable.setTable_name(table_name);
            dataRepoTable.setRepo_name(repo_name);
            dataRepoTable.setUp_num(up_num);
            dataCenterService.insertUpnum(dataRepoTable);
        } catch (Exception e) {
            connDest.rollback();
            e.printStackTrace();
        } finally {
            // 关闭各资源
            if (rs != null) {
                rs.close();
            }
            if (rsC != null) {
                rsC.close();
            }
            if (rsS != null) {
                rsS.close();
            }
            if (rsT != null) {
                rsT.close();
            }
            if (stmt != null) {
                stmt.close();
            }
            if (stmtC != null) {
                stmtC.close();
            }
            if (stmtS != null) {
                stmtS.close();
            }
            if (stmtT != null) {
                stmtT.close();
            }
            if (pstmt != null) {
                pstmt.close();
            }
            if (connSource != null) {
                connSource.close();
            }
            if (connDest != null) {
                connDest.close();
            }
        }
        return dataRepoTable;
    }

//    public static void main(String[] args) throws Exception {
//        CopyMySQL2Oracle ins = new CopyMySQL2Oracle();
//        ins.startProcess("PRODUCT");
//
//        // ...需要拷贝的表名在下面加入即可，注意顺序，比如有外键的表应该排列在主表之后。
//    }
}
